"use strict";
/**
 * Portions of this file have been extracted and modified from Swagger UI.
 *
 * @license Apache-2.0
 * @see {@link https://github.com/swagger-api/swagger-ui/blob/master/src/core/utils.js}
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
exports.deeplyStripKey = exports.isFunc = exports.normalizeArray = exports.objectify = exports.usesPolymorphism = void 0;
function isObject(obj) {
    return !!obj && typeof obj === 'object';
}
function usesPolymorphism(schema) {
    if (schema.oneOf) {
        return 'oneOf';
    }
    else if (schema.anyOf) {
        return 'anyOf';
    }
    else if (schema.allOf) {
        return 'allOf';
    }
    return false;
}
exports.usesPolymorphism = usesPolymorphism;
function objectify(thing) {
    if (!isObject(thing)) {
        return {};
    }
    return thing;
}
exports.objectify = objectify;
function normalizeArray(arr) {
    if (Array.isArray(arr)) {
        return arr;
    }
    return [arr];
}
exports.normalizeArray = normalizeArray;
// eslint-disable-next-line @typescript-eslint/ban-types
function isFunc(thing) {
    return typeof thing === 'function';
}
exports.isFunc = isFunc;
// Deeply strips a specific key from an object.
//
// `predicate` can be used to discriminate the stripping further,
// by preserving the key's place in the object based on its value.
// @todo make this have a better type than `any`
function deeplyStripKey(input, keyToStrip, predicate // eslint-disable-line @typescript-eslint/no-unused-vars
) {
    if (predicate === void 0) { predicate = function (obj, key) { return true; }; }
    if (typeof input !== 'object' || Array.isArray(input) || input === null || !keyToStrip) {
        return input;
    }
    var obj = __assign({}, input);
    Object.keys(obj).forEach(function (k) {
        if (k === keyToStrip && predicate(obj[k], k)) {
            delete obj[k];
            return;
        }
        obj[k] = deeplyStripKey(obj[k], keyToStrip, predicate);
    });
    return obj;
}
exports.deeplyStripKey = deeplyStripKey;
