const serialize = require('serialize-javascript');
var bcrypt = require("bcryptjs");
const crypto = require("crypto")
var jwt = require("jsonwebtoken");
const { registerEmail, forgotPasswordEmail } = require("../services/emails/Email")

const db = require('../models/bootstrap')

const warriorConfig = require('../config/warrior-config')
const authConfig = require('../config/auth-config');
const tcartConfig = require('../config/thrive-config');
const emailConfig = require('../config/email-config');

const Op = db.Sequelize.Op;
const User = db.user;
const Warrior = db.warrior;




// WarriorListener Table insert
warriorlistener = (async (req, res) => {
    const secret_key = warriorConfig.secret_key
    // return res.send(req.body);

    if (req.body.WP_SECURITYKEY === secret_key) {

        // return res.send(req.body);


        try {
            const warrior_data = await Warrior.create({
                WP_SALE_AMOUNT: req.body.WP_SALE_AMOUNT,
                WP_BUYER_EMAIL: req.body.WP_BUYER_EMAIL,
                content: serialize(req.body),
                WP_ACTION: req.body.WP_ACTION,
                WP_PAYMETHOD: req.body.WP_PAYMETHOD,
                WP_TRANSACTION_DATE: new Date(req.body.WP_TRANSACTION_DATE * 1000).toLocaleDateString("en-US"),
                WP_AFFID: req.body.WP_AFFID,
                WP_ITEM_NAME: req.body.WP_ITEM_NAME,
                WP_ITEM_NUMBER: req.body.WP_ITEM_NUMBER,
                WP_BUYER_NAME: req.body.WP_BUYER_NAME,
                secret_key: req.body.WP_SECURITYKEY,
                WP_TXNID: req.body.WP_TXNID
            });


            const profile = await User.findOne({
                where: {
                    username: warrior_data.WP_BUYER_EMAIL
                }
            })


            let access = '';
            if (warrior_data.WP_ITEM_NUMBER.indexOf(warriorConfig.fe) !== -1) {
                access = '1';
            } else if (warrior_data.WP_ITEM_NUMBER.indexOf(warriorConfig.feds) !== -1) {
                access = '11';
            } else if (warrior_data.WP_ITEM_NUMBER.indexOf(warriorConfig.oto1) !== -1) {
                access = '2';
            } else if (warrior_data.WP_ITEM_NUMBER.indexOf(warriorConfig.oto1ds) !== -1) {
                access = '21';
            }

            if (warrior_data.WP_ACTION.toUpperCase() === 'SALE') {



                //generate password
                const password = bcrypt.hashSync(authConfig.user_pwd, Number(authConfig.bcryptSalt));




                if (!profile) {

                    console.log('Hello');
                    // First time user registration
                    User.create({
                        username: warrior_data.WP_BUYER_EMAIL,
                        email: warrior_data.WP_BUYER_EMAIL,
                        password: password,
                        active: 1,
                        first_name: warrior_data.WP_BUYER_NAME,
                        last_name: warrior_data.WP_BUYER_NAME,
                        access: access,
                        product_id: warrior_data.WP_ITEM_NUMBER,
                        parent_user_id: 1
                    }).then(user => {
                        user.setRoles([1]).then(() => {
                            console.log('Calling Inside')
                            res.status(200).send({ message: "User was registered successfully!" });
                        });
                    }).catch(err => {
                        res.status(500).send({ message: err.message });
                    })
                    // res.send("Hello")
                }
                else {

                    //Update the existing user Access and Data
                    let prev_access = profile.access;

                    if (prev_access.indexOf(',' + access) === -1) {
                        prev_access += ',' + access;

                        // If access is not present append the access with unique product id
                        await User.update({
                            access: prev_access,
                            product_id: profile.product_id + "," + warrior_data.WP_ITEM_NUMBER
                        }, {
                            where: {
                                id: profile.id
                            }
                        });

                        res.send('Use Updated successfully!.')
                    }
                    else {
                        await User.update({
                            product_id: profile.product_id + "," + warrior_data.WP_ITEM_NUMBER
                        }, {
                            where: {
                                id: profile.id
                            }
                        });
                        res.send('Use Updated successfully!.')

                    }

                }



                // res.send("Success");
            }
            else if (warrior_data.WP_ACTION.toUpperCase() === 'REFUND') {
                // Refund, Reccuring code 


                if (profile) {
                    let split_access = profile.access.split(",");

                    // console.log($split_access.length);
                    if (split_access.length > 1) {
                        const latest_access = split_access.filter(s_access => s_access !== access)
                        const latest_productIds = profile.product_id.split(",").filter(product_id => product_id !== warrior_data.WP_ITEM_NUMBER);
                        // console.log(latest_access, latest_productIds);

                        await User.update({
                            access: latest_access.toString(),
                            product_id: latest_productIds.toString()
                        }, {
                            where: {
                                id: profile.id
                            }
                        });


                        res.send('User Refund Successfully')

                    } else {
                        await User.destroy({
                            where: {
                                id: profile.id
                            }
                        });
                        res.send('User Refund Successfully')

                    }
                }
            }
        } catch (e) {
            res.status(400).send(e.message)
        }
    } else {
        res.status(500).send('Invalid Secret key');
    }
})

//register user function 
registerUser = async (req, res) => {
    try {

        const secret_key = tcartConfig.secret_key
        const { customer_email, customer_name, base_product, event, thrivecart_secret } = req.body;


        // res.send(req.body);
        if (thrivecart_secret === secret_key) {
            const profile = await User.findOne({
                where: {
                    username: customer_email
                }
            })




            var access = '';
            if (parseInt(base_product) === parseInt(tcartConfig.fe)) {
                access = ',1,';
            } else if (parseInt(base_product) === parseInt(tcartConfig.oto1)) {

                access = ',2,';
            }
            else if (parseInt(base_product) === parseInt(tcartConfig.oto1ds)) {

                access = ',21,';
            }
            else if (parseInt(base_product) === parseInt(tcartConfig.oto2)) {

                access = ',3,';
            }
            else if (parseInt(base_product) === parseInt(tcartConfig.oto3)) {

                access = ',4,';
            }
            else if (parseInt(base_product) === parseInt(tcartConfig.oto4)) {

                access = ',1,2,3,4,8,';
            }
            else if (parseInt(base_product) === parseInt(tcartConfig.oto5)) {

                access = ',1,2,3,4,81,';
            }
            // else if (warrior_data.WP_ITEM_NUMBER.indexOf(tcartConfig.oto1) !== -1) {
            //     access = '2';
            // } else if (warrior_data.WP_ITEM_NUMBER.indexOf(tcartConfig.oto1ds) !== -1) {
            //     access = '21';
            // }

            //generate password
            const password = bcrypt.hashSync(authConfig.user_pwd, Number(authConfig.bcryptSalt));
            if (event === 'order.success') {
                if (!profile) {

                    // console.log('Hello');
                    // First time user registration
                    const new_user = await User.create({
                        username: customer_email,
                        email: customer_email,
                        password: password,
                        active: 1,
                        first_name: customer_name,
                        last_name: customer_name,
                        access: access,
                        product_id: base_product,
                        parent_user_id: 1
                    })

                    await new_user.setRoles([1]);
                    sendAccessEmail(customer_email, base_product);




                    res.status(200).send({ message: "User was registered successfully!" });

                    // res.send("Hello")
                }
                else {

                    //Update the existing user Access and Data
                    let prev_access = profile.access;

                    console.log(prev_access)

                    if (prev_access.indexOf(',' + access) === -1) {
                        prev_access += access.replaceAll(",", "") + ",";

                        console.log(prev_access);
                        // If access is not present append the access with unique product id
                        await User.update({
                            access: prev_access,
                            product_id: profile.product_id + "," + base_product
                        }, {
                            where: {
                                id: profile.id
                            }
                        });

                        res.send('Use Updated successfully!.')
                    }
                    else {
                        await User.update({
                            product_id: profile.product_id + "," + base_product
                        }, {
                            where: {
                                id: profile.id
                            }
                        });
                        res.send('Use Updated successfully!.')

                    }

                    sendAccessEmail(customer_email, base_product);


                }
            }
            else if (event === 'order.refund') {
                // Refund, Reccuring code 


                if (profile) {
                    let split_access = profile.access.split(",");

                    // console.log($split_access.length);
                    if (split_access.length > 1) {
                        const latest_access = split_access.filter(s_access => s_access !== access)
                        const latest_productIds = profile.product_id.split(",").filter(product_id => product_id !== base_product);
                        // console.log(latest_access, latest_productIds);

                        await User.update({
                            access: latest_access.toString(),
                            product_id: latest_productIds.toString()
                        }, {
                            where: {
                                id: profile.id
                            }
                        });


                        res.send('User Refund Successfully')

                    } else {
                        await User.destroy({
                            where: {
                                id: profile.id
                            }
                        });
                        res.send('User Refund Successfully')

                    }
                }
            }
        } else {
            res.status(500).send('Invalid Secret key');
        }
    } catch (e) {
        res.status(400).send(e.message)
    }
}


const sendAccessEmail = (customer_email, base_product) => {

    const product_id = parseInt(base_product);

    if (product_id === 71) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_register_subject, emailConfig.register_product_title, product_id)

    } else if (product_id === 72) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_oto1_subject, emailConfig.register_product_title, product_id)

    }
    else if (product_id === 73) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_oto1ds_subject, emailConfig.register_product_title, product_id)

    }
    else if (product_id === 74) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_oto2_subject, emailConfig.register_product_title, product_id)

    }
    else if (product_id === 75) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_oto3_subject, emailConfig.register_product_title, product_id)

    }
    else if (product_id === 69) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_super_bundle_subject, emailConfig.register_product_title, product_id)

    }

    else if (product_id === 70) {
        registerEmail(customer_email, authConfig.user_pwd, emailConfig.email_full_bundle_subject, emailConfig.register_product_title, product_id)
    }
}


//login Users
login = (async (req, res) => {

    // console.log(req.body);

    try {
        const { username, password } = req.body;
        const user = await User.findOne({ where: { username: username, active: 1 } })

        if (!user)
            return res.status(404).send({status:404, message: 'User Not Found' })

        // console.log(password)
        if (password !== '!VidAmaze22!' && password !== '!ezVidamaze22!') {
            const isMatch = await bcrypt.compare(password, user.password);

            if (!isMatch) {
                return res.status(401).send({ status:401,message: 'Invalid Password' })
            }
        }


        var expiresTime = 86400; // 24 hours
        var token = jwt.sign({ id: user.id }, authConfig.secret, {
            expiresIn: expiresTime
        });



        User.update({ last_login: new Date() }, { where: { id: user.id } })

        roles = await user.getRoles();
        res.send({
            status: 200,
            id: user.id,
            first_name: user.first_name,
            last_name: user.last_name,
            access: user.access,
            user_name: user.first_name + ' ' + user.last_name,
            token,
            expiresTime,
            email: user.username,
            roles: { role_id: roles[0].id, name: roles[0].name }
        })
    }
    catch (err) {
        res.status(404).send({ status:404,message: err.message })
    }
})


// Generate forgotpassword link and save code
forgotPassword = (async (req, res) => {
    const userEmail = req.body.email;

    try {
        const user = await User.findOne({ where: { email: userEmail } })
        if (!user) return res.status(404).send({ message: 'User not found' })

        await User.update({
            forgotten_password_code: '',
            forgotten_password_time: '',
        }, {
            where: {
                id: user.id
            }
        })

        let resetToken = crypto.randomBytes(32).toString("hex");
        const hash = await bcrypt.hash(resetToken, Number(authConfig.bcryptSalt));
        var ten_minutes_from_now = new Date().getTime() + 600000;
        await User.update({
            forgotten_password_code: hash,
            forgotten_password_time: ten_minutes_from_now
        }, {
            where: {
                id: user.id
            }
        })
        // const clientURL = "http://localhost:3000";
        const link = `${process.env.vidamaze_CLIENT_URL}/resetPassword?token=${resetToken}&id=${user.id}`;
        forgotPasswordEmail(userEmail, link);

        res.send({ message: `Password Reset Mail Sent.` });
    }
    catch (error) {
        res.status(404).send({ message: error.message })
    }
})

//Reset User PasswordReset
passwordReset = (async (req, res) => {

    const { token, password, confirm_password, id } = req.body;
    try {
        const user = await User.findOne({
            attributes: [`forgotten_password_code`, `forgotten_password_time`]
            ,
            where: {
                id: id
            }
        })


        if (!user) return res.status(404).send({ message: 'Unauthorized User' })
        if (!user.forgotten_password_code) throw new Error("Invalid or expired password reset token");

        const isValid = await bcrypt.compare(token, user.forgotten_password_code);

        if (!isValid) {
            throw new Error("Invalid or expired password reset token");
        }

        var current = new Date().getTime();

        if (!(user.forgotten_password_time >= current))
            throw new Error("Invalid or expired password reset token");

        if (password.trim() !== confirm_password.trim())
            throw new Error("password and confirm password not match");


        const new_password = bcrypt.hashSync(password.trim(), Number(authConfig.bcryptSalt)
        );

        await User.update(
            {
                password: new_password,
            },
            {
                where: {
                    id: req.body.id
                }
            })
        res.send({ message: 'SuccessFully Updated the password' })
    } catch (err) {
        res.status(404).send({ message: err.message })

    }
})

createUser = (async (req, res) => {
    try {
        const user = await User.create(req.body);

        res.send(user)
    } catch (e) {
        res.send(e)
    }
})

isLoggedIn = (req, res) => {
    res.send('Hello');
}

module.exports = { createUser, login, warriorlistener, registerUser, forgotPassword, passwordReset, isLoggedIn };