
const db = require('../../models/bootstrap')

const Op = db.Sequelize.Op;

const Autoresponder = db.autoresponder;

/*
    CURD operation on Autoresponder KEy
    User have Many API keys (1:M)
*/
const inserKeys = async (req, res) => {
    try {
        const { meta_key, meta_data } = req.body;

        const row = await Autoresponder.findOne({
            where: {
                user_id: req._user_id,
                meta_key: meta_key
            }
        });

        if (!row) {
            // insert Data
            const res = await Autoresponder.create({
                meta_key, meta_data: JSON.stringify(meta_data), user_id: req._user_id, status: 1
            })


        }
        else {
            // update data
            const res = await Autoresponder.update({
                meta_data: JSON.stringify(meta_data),
                status: 1
            }, {
                where: {
                    meta_key, user_id: req._user_id
                }
            })
        }

        res.send({ status: 200, message: "Successfully Updated..." })
    } catch (error) {
        console.log(error)
    }
}


/*
    Fetch All Autoresponder keys with all columns
*/
const fetchAllKeys = async (req, res) => {
    try {
        const response = await Autoresponder.findAll({
            where: {
                user_id: req._user_id
            }
        })


        res.send({ body: response })

    } catch (error) {
        console.log(error)
    }
}

/*
    Set status = 0 to deactive the autoresponder 
*/
const disconnectResponder = async (req, res) => {
    try {
        const { meta_key } = req.body;

        await Autoresponder.update({
            status: 0
        }, {
            where: {
                meta_key, user_id: req._user_id
            }
        })

        res.send({ message: "Successfully disconneted.." })
    } catch (error) {

    }
}



module.exports = {
    inserKeys,
    fetchAllKeys,
    disconnectResponder
}