const db = require('../../models/bootstrap')
const Op = db.Sequelize.Op;
const Autoresponder = db.autoresponder;
const axios = require('axios').default;

const getLists = async (req,res) =>{
    const {access_token,refresh_token} = req.body

    const BASE_URL = "https://api.aweber.com/1.0/";
    // console.log(access_token,refresh_token)

    const refresToken = await getRefreshToken(refresh_token);

    if(refresToken && refresToken.status === 200){
        // console.log(refresToken.data,req._user_id)
        const res = await Autoresponder.update({
            meta_data: JSON.stringify(refresToken.data),
            status: 1
        }, {
            where: {
                meta_key :"aweber", user_id: req._user_id
            }
        })
    }

    const accessToken = refresToken.data.access_token;

    const accounts = await getCollection(accessToken, BASE_URL+'accounts');

    const accountUrl = accounts[0].self_link;

	// get all the list entries for the first account
	const listsUrl = accounts[0].lists_collection_link;
    // console.log(listsUrl)
    const lists = await getCollection(accessToken, listsUrl);

    if(lists && lists.length > 0){
        const arr = lists.map((list)=>{
            return {
                id:list.id,
                name:list.name
            }
        })
        // console.log(arr);
        res.send({statusCode:200,data:arr})
    }
    // console.log(lists)
}

const getRefreshToken = async (refresh_token) =>{

    const TOKEN_URL = 'https://auth.aweber.com/oauth2/token';
    const clientId = "Ql38D1tSFIxbXMDrqwvdJxHjotyTmb8p";

    return new Promise((resolve, reject) => {

        const response = axios({
            // make a POST request
            method: "post",
            // to the Github authentication API, with the client ID, client secret
            // and request token
            url: `${TOKEN_URL}?grant_type=refresh_token&refresh_token=${refresh_token}&client_id=${clientId}`,
            // Set the content type header, so that we get the response in JSOn
            headers: {
              accept: "application/json",
              "Authorization":"Basic UWwzOEQxdFNGSXhiWE1EcnF3dmRKeEhqb3R5VG1iOHA6"
            },
            responseType: 'json'
        })

        resolve(response);

    })

    // console.log(response)
}

const getCollection = async (accessToken,url) =>{
    
    return new Promise((resolve, reject) => {
        if(url){
            const headers = {
                "Accept": "application/json",
                "User-Agent": "AWeber-Node-code-sample/1.0",
                "Authorization": `Bearer ${accessToken}`
            };
            
            // const response = fetch(url, { headers: headers })
            fetch(url, { headers: headers })
            .then(response => response.json())
            .then(data => {
                resolve(data.entries);
            })
          
        }
    });
}

module.exports={
    getLists   
}