const serialize = require('serialize-javascript');

const db = require('../models/bootstrap')

const Op = db.Sequelize.Op;
const Personalize = db.personalization;
const Campaign = db.campaign;
const fs = require('fs')

insert = async (req, res) => {
    try {
        // res.send({ msg: "Hello" })
        const { camp_id , type ,id } = req.body
        // console.log(req.body)
        const data = await Personalize.findOne({
            attributes: ['meta_data'],
            where: {
                campaigns_id: camp_id,
                meta_type : type
            },
        })

        if(type === 'emoji_content'){
            if (id) {
                const response = await Personalize.update({ 
                        meta_data: serialize(req.body) 
                    }, { 
                        where: { 
                            meta_type: type, 
                            id: id 
                        } 
                    }
                )
    
                if (!response) return res.status(401).send({ message: 'Unable to Update Data' })
    
                res.send({ status:200,message: 'Successfully Updated',id:data.id })
    
            }else{
                console.log('insert here')
                const insertData = await Personalize.create({
                    meta_type:type,
                    campaigns_id:camp_id,
                    meta_data:serialize(req.body)
                });
    
                res.send({ status:200,message: 'Saved Successfully.',id: insertData.id })
            }
        }else if (data) {

            // console.log('update here')
            const response = await Personalize.update({ 
                    meta_data: serialize(req.body) 
                }, { 
                    where: { 
                        meta_type: type, 
                        campaigns_id: camp_id 
                    } 
                }
            )

            if (!response) return res.status(401).send({ message: 'Unable to Update Data' })

            res.send({ status:200,message: 'Successfully Updated',id:data.id })

        }else{
            console.log('insert here')
            const insertData = await Personalize.create({
                meta_type:type,
                campaigns_id:camp_id,
                meta_data:serialize(req.body)
            });

            res.send({ status:200,message: 'Saved Successfully.',id: insertData.id })
        }

    } catch (error) {
        // console.log(error)
        res.status(404).send({ message: error.message })
    }
}

fetchData = async (req,res) => {
    try{

        // const dir = './icons/smiley/show'
        // const files = fs.readdirSync(dir)
        // var smileyIcons = [];

        // for (const file of files) {
        //     // console.log(file)
        //     smileyIcons.push(file)
        // }

        // console.log(smileyIcons)

        const camp_id = req.params.camp_id;

        const data = await Personalize.findAll({ where: { campaigns_id: camp_id } })
        if (data.length > 0) {
            res.send({body:data})
        }else{
            res.send({body:{}})
        }

    }catch(error){
        console.log(error)
    }
}

deleteData = async (req,res) => {
   try{
        const { camp_id , id  } = req.body
        // console.log(req.body)
        const data = await Personalize.findOne({
            attributes: ['meta_data'],
            where: {
                campaigns_id: camp_id,
                id : id
            },
        })

        if(data){
            await Personalize.destroy({
                where: {
                    campaigns_id: camp_id,
                    id
                }
            })
    
            res.send({ status: 200, message: "deleted" })
        }

   }catch(error){
       res.status(404).send({message: error.message})
   }
}

module.exports = {
    insert,
    fetchData,
    deleteData
}