module.exports = (sequelize, Sequelize) => {
    const Campaign = sequelize.define("campaigns", {
        id: {
            type: Sequelize.INTEGER,
            primaryKey: true,
            autoIncrement: true,
        },
        name: {
            type: Sequelize.STRING
        },
        keywords: {
            type: Sequelize.STRING
        },
        description: {
            type: Sequelize.TEXT
        },
        video_type: {
            type: Sequelize.STRING,
            defaultValue: 'upload'
        },
        render_status: {
            type: Sequelize.TEXT,
        },
        render_progress: {
            type: Sequelize.INTEGER,
            defaultValue: 0
        },
        status: {
            type: Sequelize.INTEGER,
        },
        video_path: {
            type: Sequelize.TEXT
        },
        render_message: {
            type: Sequelize.TEXT,
        },
        is_delete: {
            type: Sequelize.INTEGER,
            defaultValue: 0
        },
        campaign_data: {
            type: Sequelize.TEXT,
        },
        campaign_slide_urls: {
            type: Sequelize.TEXT
        },
        audio_path: {
            type: Sequelize.STRING
        },
        process_flow: {
            type: Sequelize.INTEGER,
            defaultValue: 0
        },
        assets_data: {
            type: Sequelize.TEXT
        },
        delete_slides: {
            type: Sequelize.TEXT
        },
        poster: {
            type: Sequelize.TEXT
        },
        default_poster: {
            type: Sequelize.TEXT
        },
        template_id: {
            type: Sequelize.INTEGER
        },
        gif_url: {
            type: Sequelize.TEXT
        },
        upload_thumb: {
            type: Sequelize.TEXT
        },
        trim_data: {
            type: Sequelize.TEXT,
            defaultValue: null
        },
        video_duration: {
            type: Sequelize.INTEGER,
            defaultValue: 0
        },
        instance_details: {
            type: Sequelize.TEXT,
            defaultValue: null
        } 
    });




    return Campaign;
};