const Sequelize = require('sequelize')

const sequelize = require('../config/database')

module.exports = db = {}
db.Sequelize = Sequelize;
db.sequelize = sequelize;

db.warrior = require('./Warriorlistener.model')(sequelize, Sequelize)
db.user = require('./Users.model')(sequelize, Sequelize)
db.role = require('./Role.model')(sequelize, Sequelize)
db.setting = require('./Setting.model')(sequelize, Sequelize)
db.campaign = require('./Campaign.model')(sequelize, Sequelize)
db.template = require('./Template.model')(sequelize, Sequelize)
db.usertemplate = require("./Userstemplate")(sequelize, Sequelize)
db.slides = require("./Slide.model")(sequelize, Sequelize)
// db.subdoamin = require("./subdomain.model")(sequelize, Sequelize)
db.personalization = require("./Personalization.model")(sequelize, Sequelize)
// db.analytics = require("./Analytics.model")(sequelize, Sequelize)
db.autoresponder = require("./Autoresponser.model")(sequelize, Sequelize)
// db.emailStats = require("./EmailStats.model")(sequelize, Sequelize)
// db.webpush = require("./Webpush.model")(sequelize, Sequelize);
db.landingpage = require("./LandingPage.model")(sequelize, Sequelize)  //landing page module integrated //23-02-2022
// db.pollaction = require("./PollResult.model")(sequelize, Sequelize)


db.role.belongsToMany(db.user, {
    through: "user_roles",
    foreignKey: "role_id",
    otherKey: "user_id"
});

db.user.belongsToMany(db.role, {
    through: "user_roles",
    foreignKey: "user_id",
    otherKey: "roleId"
});



// subdoamin modal relation with campaign and users
// // db.subdoamin.belongsTo(db.campaign) //create campaign_id in subdomain_table (1:1)
// db.user.hasMany(db.subdoamin, { foreignKey: 'user_id' }) //create user_id in subdoamin table(1:M)

// Personalization modal relation with campaign and users
// db.campaign.hasMany(db.personalization, { onDelete: 'CASCADE' }) //create campaign_id in subdomain_table (1:1)
// Personalization modal relation with campaign and users
db.campaign.hasMany(db.personalization, { onDelete: 'CASCADE', foreignKey: 'campaigns_id' }) //create campaigns_id in personalization_table (1:1)



// analytics modal relation with campaign 
// // db.campaign.hasMany(db.analytics, { onDelete: 'CASCADE', foreignKey: 'camp_id', }) //create campaign_id in analytics table(1:M)

// Poll action modal relation with campaign 
// // db.campaign.hasMany(db.pollaction, { onDelete: 'CASCADE', foreignKey: 'camp_id', }) //create campaign_id in pollresults table(1:M)

// // db.analytics.belongsTo(db.campaign, { foreignKey: 'camp_id' })

// db.campaign.associate = (models) => {
//     db.campaign.belongsTo(db.analytics, {
//         as: 'reports',
//         foreignKey: 'camp_id'
//     })
// }

// db.analytics.associate = (models) => {
//     db.analytics.belongsTo(db.campaign, {
//         as: 'camp_reports',
//         foreignKey: 'camp_id'
//     })
// }

// autoresponder modal relation with user 
db.user.hasMany(db.autoresponder, { onDelete: 'CASCADE' }) //create campaign_id in autoresponder table(1:M)


// Emailstats modal relation with campaign 
// // db.campaign.hasMany(db.emailStats, { onDelete: 'CASCADE' }) //create campaign_id in autoresponder table(1:M)


//Webpush model relation with users
// // db.webpush.belongsTo(db.user, { onDelete: 'CASCADE', foreignKey: 'user_id' })


db.landingpage.belongsTo(db.campaign, { onDelete: 'CASCADE', foreignKey: 'camp_id' })


db.user.hasMany(db.setting, { foreignKey: 'user_id' });
db.template.hasMany(db.slides, { foreignKey: 'template_id' })
db.user.hasMany(db.campaign, { foreignKey: 'user_id', onDelete: 'CASCADE' })
// db.template.hasMany(db.campaign, { foreignKey: 'template_id' })


const initial = () => {

    const Role = db.role;

    Role.findOne({
        where: {
            id: 1
        }
    }).then(role => {
        // console.log(role, 'Hello');
        if (!role) {
            Role.create({
                id: 1,
                name: "General User"
            }).catch(function (err) {
                // print the error details
                console.log(err);
            });
        }
    })

    Role.findOne({
        where: {
            id: 2
        }
    }).then(role => {
        // console.log(role);
        if (!role) {
            Role.create({
                id: 2,
                name: "admin"
            }).catch(function (err) {
                // print the error details
                console.log(err);
            });
        }
    })

    Role.findOne({
        where: {
            id: 3
        }
    }).then(role => {
        // console.log(role);
        if (!role) {
            Role.create({
                id: 3,
                name: "Super Admin"
            }).catch(function (err) {
                // print the error details
                console.log(err);
            });
        }
    })
}


db.initial = initial;
// sequelize.sync({ force: true });

db.ROLES = ["user", "admin", "Super Admin"];

sequelize
    .authenticate()
    .then(() => {
        console.log('Connection has been established successfully.');
    })
    .catch(err => {
        console.error('Unable to connect to the database:', err);
    });

