const router = require('express').Router();
const auth = require('../../middleware/auth');
const activeCampaign = require('../../controller/autoresponders/activeCampaign')
const aweber = require("../../controller/autoresponders/aweber")
const mailchimp = require('../../controller/autoresponders/mailchimp.controller')
const autoresponder = require('../../controller/autoresponders/autoresponder')
const getResponse = require('../../controller/autoresponders/getResponse')

router.get("/", (req, res) => {
    res.send("Autoresponder  Calling")
})

router.get("/fetchAllKeys", auth, autoresponder.fetchAllKeys)
router.post('/inserKeys', auth, autoresponder.inserKeys)

router.post('/validateActivecamp', auth, activeCampaign.checkIsvalid)
router.post('/getActiveCampaignList', auth, activeCampaign.fetchList)

// disconeect any of the responder
router.post('/disconnectResponder', auth, autoresponder.disconnectResponder)

//aweber
router.post('/getAweberLists', auth, aweber.getLists)

// Mailchimp requests
router.post('/validateMailchimp', auth, mailchimp.checkIsvalid);
router.post('/getMailchimpLists', auth, mailchimp.getLists)


// Getresponse request
router.post('/validateGetresponse', auth, getResponse.checkIsvalid)
router.post('/getGetresponseLists', auth, getResponse.getLists)


module.exports = router;