const router = require('express').Router();
const campaignController = require('../../controller/campaign.controller')
const auth = require('../../middleware/auth');

const multer = require("multer");
var storage = multer.memoryStorage();
var upload = multer({ storage: storage });

router.get("/", (req, res) => {
    res.send("Campaign Calling")
})


router.get("/getCampaigns", auth, campaignController.getCampaigns)
router.get("/getCampaigns/:page_no/", auth, campaignController.getCampaigns)
router.get("/getAllCampaigns", auth, campaignController.getAllCampaigns)

router.post('/checkCampaign', auth, campaignController.checkCampaign)
router.post('/insert', auth, campaignController.insert)
router.post('/createCampaign', auth, campaignController.insertCampaign)
router.get('/fetchcamp/:camp_id', auth, campaignController.fetchCampaign)
router.get('/myImages', auth, campaignController.fetchImages)

// delete Campaign
router.delete('/deleteCampaign/:id', auth, campaignController.deleteCampaign)

router.post('/updateCampaign', auth, campaignController.updateCampaign)


// 7-6-22
router.get('/myMedia', auth, campaignController.fetchMedia);
router.post('/trimVideo', auth, campaignController.createTrimVideo)

router.post('/uploadImage', [auth, upload.single('file')], campaignController.uploadImage)
router.post('/uploadVideo', [auth, upload.single('file')], campaignController.uploadVideo)
router.post('/uploadAudio', [auth, upload.single('file')], campaignController.uploadAudio)

router.post('/uploadURLImage', auth, campaignController.uploadURLImage)
router.post('/saveVideoData', auth, campaignController.saveVideoData)
router.post('/configureAudio', auth, campaignController.configureAudio)
router.post('/gifCreation', auth, campaignController.gifCreation)
router.post('/restartRender', auth, campaignController.restartRender)


router.post('/cloneCampaign', auth, campaignController.cloneCampaign);



//Nexrender return data routes
router.post('/setrenderData', campaignController.setrenderData)
router.get('/checkTestEmail1', campaignController.checkTestEmail)



// Fetch Single Campaign Data
router.get('/:id', auth, campaignController.fetchSingleCampaign)

module.exports = router;